Index: /gs2-extensions/video-and-audio/trunk/src/perllib/plugins/SimpleVideoPlugin.pm
===================================================================
--- /gs2-extensions/video-and-audio/trunk/src/perllib/plugins/SimpleVideoPlugin.pm	(revision 27551)
+++ /gs2-extensions/video-and-audio/trunk/src/perllib/plugins/SimpleVideoPlugin.pm	(revision 27552)
@@ -138,5 +138,5 @@
   }
 
-  print STDERR "[A:" . time() . "] SimpleVideoPlugin processing: " . $file . "\n";
+  print STDERR " * SimpleVideoPlugin processing: " . $file . "\n";
 
   # - I have to add some text (yay, back to needing dummy text) otherwise the
@@ -206,19 +206,14 @@
   if ($separate_io eq 'true')
   {
-    print STDERR "[B1:" . time() . "] Creating local copy of file: " . $ivideo_path . "\n";
+    my $io_start = time();
+    print " - creating local copy of file: " . $ivideo_path . " [IOS:" . time() . "]\n";
     my $local_ivideo_path = &FileUtils::filenameConcatenate($process_dir, $filename . ".ts");
     &FileUtils::copyFiles($ivideo_path, $local_ivideo_path);
     $ivideo_path = $local_ivideo_path;
-    print STDERR "[B2:" . time() . "] Complete\n";
-  }
-  else
-  {
-    print "Not gonna work!\n";
-    exit;
+    print " - copied! [IOE:" . time() . "]\n";
   }
 
   # 1. Use MediaInfo to extract important metadata
-  print STDERR "[C1:" . time() . "] Extracting metadata\n";
-  print " - Extracting metadata using MediaInfo\n";
+  print ' - Extracting metadata using MediaInfo...';
   my $mi_metadata = $self->getMetadata($ivideo_path);
   $doc_obj->add_utf8_metadata($topsection,"Format", 'multimedia (' . $mi_metadata->{'General'}->{'Format'} . ')');
@@ -242,18 +237,18 @@
   $doc_obj->add_utf8_metadata($topsection,"Width",$mi_metadata->{'Video'}->{'Width'});
   $doc_obj->add_utf8_metadata($topsection,"Height",$mi_metadata->{'Video'}->{'Height'});
-  print STDERR "[C2:" . time() . "] Complete\n";
+  print STDERR "Done!\n";
 
   # 2. Convert into FLV, reprocess to make seekable, and associate
   # - generate a path for our temporary converted video file
-  print STDERR "[D1:" . time() . "] Converting video to streamble format\n";
+  print STDERR " - Converting video to streamble format...\n";
   my $ovideo_path = &FileUtils::filenameConcatenate($tmp_dir, 'gsv.mp4');
   if (&FileUtils::fileExists($ovideo_path))
   {
-    print " - Found existing converted video in cache\n";
+    print "   - Found existing converted video in cache!\n";
   }
   else
   {
     # - first conversion pass
-    print " - Convert using Handbrake\n";
+    print "   - Convert using Handbrake\n";
     my $streaming_HQ_size    = $self->{'streamingHQsize'};
     my $streaming_HQ_VideoBitrate    = $self->{'streamingHQVideoBitrate'};
@@ -310,16 +305,16 @@
     die("Fatal Error! Failed to convert video: " . $ovideo_path . "\nReason:" . $! . "\n");
   }
-  print STDERR "[D2:" . time() . "] Complete\n";
+  print STDERR " - conversion done!\n";
 
   # 3. Extract keyframes using hive
-  print STDERR "[E1:" . time() . "] Extract keyframes\n";
+  print STDERR " - extract keyframes...\n";
   my $oshots_path = &FileUtils::filenameConcatenate($tmp_dir, 'shots.xml');
   if (&FileUtils::fileExists($oshots_path))
   {
-    print " - Found existing keyframe images in cache\n";
+    print "   - found existing keyframe images in cache\n";
   }
   else
   {
-    print " - Generating keyframe images using Hive2\n";
+    print "   - generating keyframe images using Hive2\n";
     my $cmd = 'hive2_ffmpegsvn -o "' . $oshots_path . '" -k "' . $tmp_dir . '" "' . $ovideo_path . '" >> "' . $convert_log_path . '" 2>&1';
     ###print "[cmd: " . $cmd . "]\n";
@@ -330,9 +325,9 @@
     die("Fatal Error! Failed to extract keyframe images: " . $oshots_path . "\nReason:" . $! . "\n");
   }
-  print STDERR "[E2:" . time() . "] Complete\n";
+  print STDERR "  - keyframes extracted!\n";
 
 
   # 4. Associate files (copies back to shared space if IO separated)
-  print STDERR "[F1:" . time() . "] Associate derived files to doc_obj\n";
+  print STDERR " - Associate derived files to doc_obj... ";
   # - associate streamable video
   $doc_obj->associate_file($ovideo_path,'gsv.mp4','video/mp4',$topsection);
@@ -356,8 +351,8 @@
     }
   }
-  print STDERR "[F2:" . time() . "] Complete\n";
+  print STDERR "Done!\n";
 
   # 5. Done! Cleanup.
-  print STDERR "[G:" . time() . "] SimpleVideoPlugin: Complete!\n";
+  print STDERR "SimpleVideoPlugin: Complete! [IOS:" . time() . "]\n";
   return 1;
 }